Attribute VB_Name = "mSMSDecode"
Option Explicit
Public Enum PDU_PhoneTypeENUM
    phtLocal = 129 ' 81
    phtInternational = 145 ' 91
    phtUnknown = 128 ' 80
    phtShort = 177 ' B1
End Enum
Public Type DecodedSMS
    Abonent As String
    PhoneType As PDU_PhoneTypeENUM
    MsgType As SMSMessageTypeENUM
    MsgDate As Date
    MsgInDate As Date
    MsgText As String
    DeliverStatus As Long
    IDMsg As Long
End Type
'
Public Enum MessageTypeIndicatorENUM
    SMS_DELIVER = 0         '
    SMS_SUBMIT = 1          '
    SMS_COMMAND = 2
    SMS_RESERVED = 3
'0          0          SMS-DELIVER (SMSC ==> MS)
'0          0          SMS-DELIVER REPORT (MS ==> SMSC, is generated automatically by the MOBILE, after receiving a SMS-DELIVER)
'0          1          SMS-SUBMIT (MS ==> SMSC)
'0          1          SMS-SUBMIT REPORT (SMSC ==> MS)
'1          0          SMS-STATUS REPORT (SMSC ==> MS)
'1          0          SMS-COMMAND (MS ==> SMSC)
'1          1          Reserved
End Enum



'CSEH: ErrRaise
Public Function GetMTI(ByVal Value As String) As MessageTypeIndicatorENUM
    '<EhHeader>
    On Error GoTo GetMTI_Err
    '</EhHeader>
    Dim i As Integer
    Dim s As String
    Dim n As Integer
    
100     n = CInt("&H" & Value)
110     s = Dec2Bin(n)
120     i = CInt(Bin2Hex(VBA.Right$(s, 2)))
130     Select Case i
            Case 0
140             GetMTI = SMS_DELIVER
150         Case 1
160             GetMTI = SMS_SUBMIT
170         Case 2
180             GetMTI = SMS_COMMAND
190         Case Else
200             GetMTI = SMS_RESERVED
        End Select

    '<EhFooter>
lb_out:
    Exit Function

GetMTI_Err:
    LogError "GetMTI: (" & Value & ")"
    '</EhFooter>
End Function


'CSEH: ErrRaise
Public Function PhoneDecode(ByVal InputPhone As String, Optional ByVal IntCode As Boolean = False) As String
    '<EhHeader>
    On Error GoTo PhoneDecode_Err
    '</EhHeader>
    Dim i As Integer
    Dim s As String
    Dim ret As String
    Dim ss As String
    Dim s1 As String
    Dim s2 As String
    Dim n As Long
    Dim sInt As String

100     PhoneDecode = ""
110     s = VBA.Trim$(InputPhone)
120     If VBA.Len(s) = 0 Then Exit Function
130     sInt = ""
140     s = VBA.UCase$(s)
150     If IntCode Then
160         n = VBA.Mid$(s, 1, 2)
170         s = VBA.Mid$(s, 3)
180         Select Case n
                Case 80
190                 sInt = ""
200             Case 81
210                 sInt = ""
220             Case 91
230                 sInt = "+"
240             Case Else
250                 sInt = ""
            End Select
        End If
260     For i = 1 To Len(s) Step 2
270         ss = VBA.Mid$(s, i, 2)
280         s2 = VBA.Left$(ss, 1)
290         s1 = VBA.Right$(ss, 1)
300         If s1 = "F" Then
310             s1 = ""
            End If
320         If s2 = "F" Then
330             s2 = ""
            End If
340         ret = ret & s1 & s2
350     Next i
360     PhoneDecode = sInt & ret

    '<EhFooter>
lb_out:
    Exit Function

PhoneDecode_Err:
    LogError "PhoneDecode: (" & InputPhone & ")"
    '</EhFooter>
End Function

Public Function txt2pdu(ByVal stxt As String) As String
Dim s As Long
Dim Y As Integer
Dim X As String
Dim Text As String
Dim out As String
Dim L As Long

    For Y = 1 To Len(stxt)
        X = mSMSDecode.Dec2Bin(Asc(Mid(stxt, Y, 1)), True)
        'If X = "100000" Then X = "0100000"
        Text = X & Text
    Next Y
    'Debug.Print Text
    L = VBA.Len(Text)
    s = L - 7
    If s = 0 Then s = 1
    out = mSMSDecode.Bin2Hex(Mid(Text, s, 8))
    Do Until s <= 8
        s = s - 8
        out = out & mSMSDecode.Bin2Hex(Mid(Text, s, 8))
    Loop
    out = out & mSMSDecode.Bin2Hex(Mid(Text, 1, s - 1))
    'Debug.Print out
    
    X = Hex(Len(stxt))
    If Len(X) = 1 Then
        X = "0" & X
    End If
    'Debug.Print X & out
    txt2pdu = X & out
    
End Function

Public Function Dec2Bin(ByVal nDec As Integer, Optional ByVal OldVersion As Boolean = False) As String
'This function is the same then Hex2Bin,
'     but it has been copied to speed up proce
'     ss
Dim i As Integer
Dim j As Integer
Dim sHex As String
Const HexChar As String = "0123456789ABCDEF"
    
    sHex = Hex(nDec) 'That the only part that is different


    For i = 1 To Len(sHex)
        nDec = InStr(1, HexChar, Mid(sHex, i, 1)) - 1
        For j = 3 To 0 Step -1
            Dec2Bin = Dec2Bin & nDec \ 2 ^ j
            nDec = nDec Mod 2 ^ j
        Next j
    Next i
    If OldVersion Then
        'Remove the first unused 0
        i = InStr(1, Dec2Bin, "1")
        If i <> 0 Then Dec2Bin = Mid(Dec2Bin, i)
        If Len(Dec2Bin) = 6 Then Dec2Bin = "0" & Dec2Bin
    Else
        Dec2Bin = Format(Dec2Bin, "00000000")
    End If
    
End Function

Public Function Bin2Hex(ByVal sBin As String) As String
Dim i As Integer
Dim nDec As Long
    
    sBin = String(4 - Len(sBin) Mod 4, "0") & sBin 'Add zero to complete Byte
    For i = 1 To Len(sBin)
        nDec = nDec + CInt(Mid(sBin, Len(sBin) - i + 1, 1)) * 2 ^ (i - 1)
    Next i
    Bin2Hex = Hex(nDec)
    If Len(Bin2Hex) Mod 2 = 1 Then Bin2Hex = "0" & Bin2Hex
    
End Function

Public Function DSCDecode(ByVal InputStr As String, ByRef Coding As Integer) As String
Dim s As String

    Coding = 0
    InputStr = VBA.UCase$(InputStr)
    Select Case InputStr
        Case "08"
            s = "UCS2 coding"
            Coding = 2
        Case "00"
            s = "Default alphabet 7-bit data coding"
        Case "F0", "F4"
            s = "Class0 immediate display"
            If InputStr = "F4" Then
                s = s & " 8-bit coding"
                Coding = 1
            Else
                s = s & " 7-bit coding"
            End If
        Case "F1", "F5"
            s = "Class1 ME (Mobile Equipment) specific"
            If InputStr = "F5" Then
                s = s & " 8-bit coding"
                Coding = 1
            Else
                s = s & " 7-bit coding"
            End If
        Case "F2", "F6"
            s = "Class2 SIM specific message"
            If InputStr = "F6" Then
                s = s & " 8-bit coding"
                Coding = 1
            Else
                s = s & " 7-bit coding"
            End If
        Case "F3", "F7"
            s = "Class3 TE (Terminate Equipment) specific"
            If InputStr = "F7" Then
                s = s & " 8-bit coding"
                Coding = 1
            Else
                s = s & " 7-bit coding"
            End If
    End Select
    DSCDecode = s
    
End Function


Public Function VPDecode(ByVal s As String) As String
Dim L As Long
Dim ret As String
Dim i As Integer
Dim j As Single

    L = VBA.CLng("&H" & s)
    Select Case L
        Case Is <= 143  'minute <12 hours
            L = (L + 1) * 5
            i = L \ 60
            j = L / 60
            If i = 0 Then
                ret = L & " ."
            Else
                If j > i Then
                    L = L - i * 60
                    ret = i & " . " & L & " ."
                Else
                    ret = i & " ."
                End If
            End If
        Case Is <= 167  'hour >12 hours
            L = (L - 143) * 30
            i = L \ 30
            ret = i & " ."
        Case Is <= 196  'day
            L = L - 166
            ret = L & " "
        Case Is <= 255  'week
            L = L - 195
            ret = L & " "
    End Select
    VPDecode = ret
    
End Function

Public Function SCTSDecode(ByVal s As String) As String
Dim i As Integer
Dim yy As Integer
Dim mm As Integer
Dim dd As Integer
Dim hh As Integer
Dim m As Integer
Dim ss As Integer
Dim sss As String
Dim dt As Date
Dim tm As Date
Dim gmt As Integer

    yy = CInt(VBA.Mid$(s, 2, 1) & VBA.Mid$(s, 1, 1))
    mm = CInt(VBA.Mid$(s, 4, 1) & VBA.Mid$(s, 3, 1))
    dd = CInt(VBA.Mid$(s, 6, 1) & VBA.Mid$(s, 5, 1))
    dt = VBA.DateSerial(yy, mm, dd)
    
    hh = CInt(VBA.Mid$(s, 8, 1) & VBA.Mid$(s, 7, 1))
    m = CInt(VBA.Mid$(s, 10, 1) & VBA.Mid$(s, 9, 1))
    ss = CInt(VBA.Mid$(s, 12, 1) & VBA.Mid$(s, 11, 1))
    tm = VBA.DateTime.TimeSerial(hh, m, ss)
    
    gmt = CInt(VBA.Mid$(s, 14, 1) & VBA.Mid$(s, 13, 1))
    gmt = gmt / 4
    If gmt > 12 Then
        gmt = gmt - 12
        gmt = -gmt
    End If
    
    sss = Format(dt, "dd.mm.yyyy") & " " & Format(tm, "hh:MM:ss") & " " & Format(gmt, "00") & " GMT"
    SCTSDecode = sss
    

End Function

'CSEH: ErrRaise
Public Function DateDecode(ByVal s As String) As Date
'<EhHeader>
On Error GoTo DateDecode_Err
'</EhHeader>
Dim i As Integer
Dim yy As Integer
Dim mm As Integer
Dim dd As Integer
Dim hh As Integer
Dim m As Integer
Dim ss As Integer
Dim sss As String
Dim dt As Date
Dim tm As Date
Dim gmt As Integer
Dim sRazd As String

    If Len(s) = 0 Then
        Exit Function
    End If
    
100     yy = CInt(VBA.Mid$(s, 2, 1) & VBA.Mid$(s, 1, 1))
110     mm = CInt(VBA.Mid$(s, 4, 1) & VBA.Mid$(s, 3, 1))
120     dd = CInt(VBA.Mid$(s, 6, 1) & VBA.Mid$(s, 5, 1))
130     dt = VBA.DateSerial(yy, mm, dd)
    
140     hh = CInt(VBA.Mid$(s, 8, 1) & VBA.Mid$(s, 7, 1))
150     m = CInt(VBA.Mid$(s, 10, 1) & VBA.Mid$(s, 9, 1))
160     ss = CInt(VBA.Mid$(s, 12, 1) & VBA.Mid$(s, 11, 1))
170     tm = VBA.DateTime.TimeSerial(hh, m, ss)
    
        On Error Resume Next
180     gmt = CInt(VBA.Mid$(s, 14, 1) & VBA.Mid$(s, 13, 1))
190     gmt = gmt / 4
200     If gmt > 12 Then
210         gmt = gmt - 12
220         gmt = -gmt
        End If
230     If Err.Number <> 0 Then
240         Err.Clear
        End If
        
        On Error GoTo DateDecode_Err
250     sRazd = VBA.Date$
    
260     sss = Format(dt, "dd.mm.yyyy") & " " & Format(tm, "hh:MM:ss") '& " " & Format(gmt, "00") & " GMT"
270     DateDecode = CDate(sss)
    

    '<EhFooter>
lb_out:
    Exit Function

DateDecode_Err:
    LogError "DateDecode: (" & s & ")"
    '</EhFooter>
End Function


Public Function DataDecode(ByVal sInput As String) As String
Dim s As String
Dim s1 As String
Dim s2 As String
Dim sPrev As String
Dim sPrevDx As String
Dim curBin As String
Dim i As Integer
Dim L As Long
Dim ret As String
Dim sBin As String
Dim dx As Integer
Dim j As Integer
Dim sDx As String
Dim sss As String
Dim C As String
Dim cc As String

    dx = 0
    ret = ""
    sDx = ""
    sss = ""
    For i = 1 To Len(sInput) Step 2
        j = j + 1
        dx = dx + 1
        '   
        s = VBA.Mid$(sInput, i, 2)
        L = CLng("&H" & s)
        sBin = Dec2Bin(L)
        '  
        sDx = VBA.Mid$(sBin, 1, dx)
        curBin = VBA.Mid$(sBin, dx + 1)
        If dx = 1 Then
            cc = ""
            If Len(sPrevDx) = 7 Then
                cc = Chr(CLng("&H" & Bin2Hex(sPrevDx)))
            End If
            C = Chr(CLng("&H" & Bin2Hex(curBin)))
            C = cc & C
'            Debug.Print c
        Else
            curBin = curBin & sPrevDx
            C = Chr(CLng("&H" & Bin2Hex(curBin)))
'            Debug.Print c
        End If
        sss = sss & C
        ' 
        sPrev = sBin
        sPrevDx = sDx
        '
        If dx = 7 Then dx = 0
        ret = ret & sBin & " "
    Next i
    ret = VBA.Trim$(ret)
'    Debug.Print ret
'    Debug.Print sss
    
    DataDecode = sss
    
End Function

'CSEH: ErrRaise
Public Function DecodeDelivery(ByVal sTPDU As String) As DeliveryReport
'<EhHeader>
On Error GoTo DecodeDelivery_Err
'</EhHeader>
Dim s As String
Dim i As Integer
Dim sss As String
Dim scaLen As Long
Dim scaType As Long
Dim ID As MessageTypeIndicatorENUM
Dim dTPDU As DeliveryReport

100     sss = sTPDU
110     sss = VBA.Trim$(sss)
120     sss = VBA.Replace(sss, vbCrLf, "")
130     sss = VBA.Replace(sss, vbLf, "")
140     sss = VBA.Replace(sss, vbCr, "")
    
150     If VBA.Len(sss) = 0 Then Exit Function
    
160     LogInfo "DecodeDelivery: " & sss
    
170     i = 1
180     scaLen = CLng(VBA.Mid$(sss, i, 2))
        'SCA "   "
190     i = i + 2
        'SCA
        ' 
        '  
    
200     i = i + scaLen * 2
210     s = VBA.Mid$(sss, i, 2)
220     ID = mSMSDecode.GetMTI(s)
        '  TPDU
230     If ID <> SMS_COMMAND Then Exit Function
    
240     i = i + 2
250     s = VBA.Mid$(sss, i, 2)
        'MR " "
260     dTPDU.MsgID = VBA.CLng("&H" & s)
    
270     i = i + 2
280     s = VBA.Mid$(sss, i, 2)
290     scaLen = VBA.CLng("&H" & s)
        'OA
        '"  "
300     i = i + 2
310     s = VBA.Mid$(sss, i, 2)
320     scaType = VBA.CLng(s)
        'OA
        '" "
330     i = i + 2
340     If (scaLen Mod 2) Then
350         scaLen = scaLen + 1
        End If
360     s = VBA.Mid$(sss, i, scaLen)
370     s = PhoneDecode(s, False)
        'OA
        '"  "
380     dTPDU.Abonent = "+" & s
    
390     i = i + scaLen
400     s = VBA.Mid$(sss, i, 7 * 2)
        'SCTS
        '"      "
410     dTPDU.InTime = DateDecode(s)
            
420     i = i + 14
430     s = VBA.Mid$(sss, i, 7 * 2)
        'DT
        '"    "
440     dTPDU.OutTime = DateDecode(s)
            
450     i = i + 14
460     s = VBA.Mid$(sss, i, 2)
        'ST
        '" "
470     dTPDU.Status = CLng("&H" & s)

480     DecodeDelivery = dTPDU

    '<EhFooter>
lb_out:
    Exit Function

DecodeDelivery_Err:
    LogError "DecodeDelivery: (" & sss & ")"
    Resume lb_out
    '</EhFooter>
End Function


'CSEH: ErrRaise
Public Function DecodeTPDU(ByVal sTPDU As String) As DecodedSMS
    '<EhHeader>
    On Error GoTo DecodeTPDU_Err
    '</EhHeader>
    Dim s As String
    Dim i As Integer
    Dim sss As String
    Dim h As Long
    Dim scaLen As Long
    Dim scaType As Long
    Dim ID As MessageTypeIndicatorENUM
    Dim dTPDU As DecodedSMS
    Dim Coding As Integer
    Dim pduLen As Integer
    
100     sss = sTPDU
110     sss = VBA.Trim$(sss)
120     sss = VBA.Replace(sss, vbCrLf, "")
130     sss = VBA.Replace(sss, vbLf, "")
140     sss = VBA.Replace(sss, vbCr, "")
    
150     If VBA.Len(sss) = 0 Then Exit Function
    
        LogInfo "DecodeTPDU: " & sss
    
    i = 1
    scaLen = CLng(VBA.Mid$(sss, i, 2))
'    Rs.AddNew
'    Rs!Name = "SCA"
'    Rs!Description = "   "
'    Rs!Value = scaLen
'    Rs!Text = scaLen
'    Rs.Update
    
    i = i + 2
    If scaLen > 0 Then
    
    s = VBA.Mid$(sss, i, 2)
    scaType = VBA.CLng(s)
'    Rs.AddNew
'    Rs!Name = "SCA"
'    Rs!Description = " "
'    Rs!Value = scaType
'    Select Case scaType
'        Case 80
'            s = ""
'        Case 81
'            s = ""
'        Case 91
'            s = ""
'    End Select
'    Rs!Text = s
'    Rs.Update
'
'    s = VBA.Mid$(sss, i, scaLen * 2)
'    Rs.AddNew
'    Rs!Name = "SCA"
'    Rs!Description = "  "
'    Rs!Value = s
'    Rs!Text = PhoneDecode(s, True)
'    Rs.Update
    
    End If
    
    i = i + scaLen * 2
    s = VBA.Mid$(sss, i, 2)
    ID = mSMSDecode.GetMTI(s)
    Select Case ID
        Case SMS_SUBMIT
            s = "SMS-SUBMIT"
        Case SMS_DELIVER
            s = "SMS-DELIVER"
        Case SMS_COMMAND
            s = "SMS-COMMAND"
            i = i + 2
            s = VBA.Mid$(sss, i, 2) 'MR
            dTPDU.IDMsg = VBA.CLng("&H" & s)
        Case SMS_RESERVED
            s = "SMS-RESERVED"
    End Select
    
'/*
'160     i = 1
'170     scaLen = CLng(VBA.Mid$(sss, i, 2))
'    '    Rs.AddNew
'    '    Rs!Name = "SCA"
'    '    Rs!Description = "   "
'    '    Rs!Value = scaLen
'    '    Rs!Text = scaLen
'    '    Rs.Update
'
'180     i = i + 2
'
'
'190     s = VBA.Mid$(sss, i, 2)
'200     scaType = VBA.CLng("&H" & s)
'    '    Rs.AddNew
'    '    Rs!Name = "SCA"
'    '    Rs!Description = " "
'    '    Rs!Value = scaType
'    '    Select Case scaType
'    '        Case 80
'    '            s = ""
'    '        Case 81
'    '            s = ""
'    '        Case 91
'    '            s = ""
'    '    End Select
'    '    Rs!Text = s
'    '    Rs.Update
'
'210     s = VBA.Mid$(sss, i, scaLen * 2)
'    '    Rs.AddNew
'    '    Rs!Name = "SCA"
'    '    Rs!Description = "  "
'    '    Rs!Value = s
'    '    Rs!Text = PhoneDecode(s, True)
'    '    Rs.Update
'
'220     i = i + scaLen * 2
'230     s = VBA.Mid$(sss, i, 2)
'240     id = mSMSDecode.GetMTI(s)
'*/

    
    
250     dTPDU.MsgType = CLng(ID)
    
260     If ID = SMS_SUBMIT Then
270         i = i + 2
280         s = VBA.Mid$(sss, i, 2)
    '        Rs.AddNew
    '        Rs!Name = "MR"
    '        Rs!Description = " "
    '        Rs!Value = s
    '        Rs!Text = VBA.CLng("&H" & s)
    '        Rs.Update
        End If
    
290     i = i + 2
300     s = VBA.Mid$(sss, i, 2)
310     scaLen = VBA.CLng("&H" & s)
    '    Rs.AddNew
    '    Select Case id
    '        Case 11
    '            'SMS-SUBMIT
    '            Rs!Name = "DA"
    '            Rs!Description = "  "
    '        Case 4
    '            'SMS-DELIVER
    '            Rs!Name = "OA"
    '            Rs!Description = "  "
    '    End Select
    '    Rs!Value = s
    '    Rs!Text = scaLen & " "
    '    Rs.Update
    
320     i = i + 2
330     s = VBA.Mid$(sss, i, 2)
340     scaType = VBA.CLng("&H" & s)
    
350     dTPDU.PhoneType = scaType
    
    '    Rs.AddNew
    '    Select Case id
    '        Case 11
    '            Rs!Name = "DA"
    '        Case 4
    '            Rs!Name = "OA"
    '    End Select
    '    Rs!Description = " "
    '    Rs!Value = scaType
    '    Select Case scaType
    '        Case 80
    '            s = ""
    '        Case 81
    '            s = ""
    '        Case 91
    '            s = ""
    '    End Select
    '    Rs!Text = s
    '    Rs.Update
    
360     i = i + 2
370     If (scaLen Mod 2) Then
380         scaLen = scaLen + 1
        End If
390     s = VBA.Mid$(sss, i, scaLen)
    
400     dTPDU.Abonent = "+" & PhoneDecode(s)
    
    '    Rs.AddNew
    '    Select Case id
    '        Case 11
    '            Rs!Name = "DA"
    '            Rs!Description = "  "
    '        Case 4
    '            Rs!Name = "OA"
    '            Rs!Description = "  "
    '    End Select
    '    Rs!Value = s
    '    Rs!Text = PhoneDecode(s)
    '    Rs.Update
    
    i = i + scaLen
    
    If ID <> SMS_COMMAND Then
'    s = VBA.Mid$(sss, i, 2)
'    Rs.AddNew
'    Rs!Name = "PID"
'    Rs!Description = " "
'    Rs!Value = s
'    Select Case VBA.CLng(s)
'        Case 0
'            s = " SMS"
'        Case 41
'            s = " 1"
'        Case 42
'            s = " 2"
'        Case 43
'            s = " 3"
'        Case 47
'            s = " 7"
'    End Select
'    Rs!Text = s
'    Rs.Update

    i = i + 2
    s = VBA.Mid$(sss, i, 2)
    s = DSCDecode(s, Coding)
'    Rs.AddNew
'    Rs!Name = "DCS"
'    Rs!Description = "  "
'    Rs!Value = s
'    Rs!Text = DSCDecode(s, C)    'c=0-7bit,c=1-8bit
'    Rs.Update
    
    i = i + 2
    End If
    
'/*
'410     i = i + scaLen
'420     s = VBA.Mid$(sss, i, 2)
'    '    Rs.AddNew
'    '    Rs!Name = "PID"
'    '    Rs!Description = " "
'    '    Rs!Value = s
'    '    Select Case VBA.CLng(s)
'    '        Case 0
'    '            s = " SMS"
'    '        Case 41
'    '            s = " 1"
'    '        Case 42
'    '            s = " 2"
'    '        Case 43
'    '            s = " 3"
'    '        Case 47
'    '            s = " 7"
'    '    End Select
'    '    Rs!Text = s
'    '    Rs.Update
'
'430     i = i + 2
'440     s = VBA.Mid$(sss, i, 2)
'    '    Rs.AddNew
'    '    Rs!Name = "DCS"
'    '    Rs!Description = "  "
'    '    Rs!Value = s
'450     s = DSCDecode(s, Coding)
'    '    Rs.Update
'
'460     i = i + 2
'
'*/

470     Select Case ID
            Case SMS_COMMAND
                s = VBA.Mid$(sss, i, 7 * 2)
                dTPDU.MsgInDate = DateDecode(s)
'                Rs.AddNew
'                Rs!Name = "SCTS"
'                Rs!Description = "      "
'                Rs!Value = s
'                Rs!Text = SCTSDecode(s)
'                Rs.Update
                i = i + 14
                s = VBA.Mid$(sss, i, 7 * 2)
'                Rs.AddNew
'                Rs!Name = "DT"
'                Rs!Description = "    "
'                Rs!Value = s
                dTPDU.MsgDate = DateDecode(s)
'                Rs!Text = SCTSDecode(s)
'                Rs.Update
                i = i + 14
                s = VBA.Mid$(sss, i, 2)
'                Rs.AddNew
'                Rs!Name = "ST"
'                Rs!Description = " "
'                Rs!Value = s
'                Rs!Text = CLng("&H" & s)
'                Rs.Update
                dTPDU.DeliverStatus = CLng("&H" & s)
                GoTo lb_show
            Case SMS_SUBMIT
480             s = VBA.Mid$(sss, i, 2)
    '            Rs.AddNew
    '            Rs!Name = "VP"
    '            Rs!Description = " .          ."
    '            Rs!Value = s
    '            Rs!Text = VPDecode(s)
    '            Rs.Update
490             i = i + 2
            
500             dTPDU.MsgDate = VBA.Now
            
510         Case SMS_DELIVER
520             s = VBA.Mid$(sss, i, 7 * 2)
    '            Rs.AddNew
    '            Rs!Name = "SCTS"
    '            Rs!Description = "    "
    '            Rs!Value = s
    '            Rs!Text = SCTSDecode(s)
    '            Rs.Update
530             i = i + 14
            
540             dTPDU.MsgDate = DateDecode(s)
            
        End Select
550     s = VBA.Mid$(sss, i, 2)
555     pduLen = CLng("&H" & s)
    '    Rs.AddNew
    '    Rs!Name = "UDL"
    '    Rs!Description = " "
    '    Rs!Value = s
    '    Rs!Text = CLng("&H" & s)
    '    Rs.Update
560     i = i + 2
570     s = VBA.Mid$(sss, i)
    '    Rs.AddNew
    '    Rs!Name = "UD"
    '    Rs!Description = ""
    '    Rs!Value = s
    '    Rs!Text = DataDecode(s)
    '    Rs.Update
580     If Coding = 1 Then
590         dTPDU.MsgText = ANSIDecode(s)
        ElseIf Coding = 2 Then
            dTPDU.MsgText = USC2Decode(s)
        Else
600         dTPDU.MsgText = pdu2text(s, pduLen)
        End If
        
lb_show:
610     DecodeTPDU = dTPDU

    '<EhFooter>
lb_out:
    Exit Function

DecodeTPDU_Err:
    LogError "DecodeTPDU"
    Resume lb_out
    '</EhFooter>
End Function

Public Function EncodeTPDU( _
    ByVal Abonent As String, _
    ByVal Msg As String, _
    ByRef TPDULen As Long, _
    Optional ByVal USC2 As Boolean = False, _
    Optional ByVal PhoneType As String = "") As String
        '<EhHeader>
        On Error GoTo EncodeTPDU_Err
        '</EhHeader>
    Dim sss As String
    Dim pduRet As String
    Dim sType As String
    Dim sAbonent As String
    Dim phLen As Integer
    Dim sLen As String
    Dim DSC As String

    ' this line of code converts the 11 char handy number to a readable nuber for the siemens mobile phone
    ' like this ,  1 2 3 4 5 6 7 8 9 10 11 -----> 2 1 4 3 6 5 8 7 10 9 F 11 , every number
    ' should be a mobile number char.
    
110     sss = PhoneEncode(Abonent, phLen, PhoneType)
        ' this converts the sms text into 7 bit pdu data
        If USC2 Then
            pduRet = USC2Encode(VBA.Left$(Msg, 70))
            If Len(VBA.Hex$(Len(pduRet) / 2)) = 1 Then
                pduRet = "0" & VBA.Hex$(Len(pduRet) / 2) & pduRet
            Else
                pduRet = VBA.Hex$(Len(pduRet) / 2) & pduRet
            End If
        Else
100         Msg = mSMS.NormalizeMessage(Msg, modePDU)
120         pduRet = mSMSDecode.txt2pdu(Msg)
        End If
    '    ' this you need as head of the message
    '    N = "0011000B91" 'This is for 11 digit cellphone numbers international.
    '    ' a part of the head too
    '    L = "0000" '7 bit data now
    '    0A -       (55 min)
130     sType = "91"        ' 
140     sLen = Hex(phLen)   '  
150     If Len(sLen) = 1 Then
160         sLen = "0" & sLen
        End If
        '
        '11 -   
        '31 -   
        '
        'PDUtype    MR  DA                  PID DCS VP
        '31         00  sLen & SType & sss  00  00  0A
        '
        If USC2 Then
            DSC = "08"
        Else
            DSC = "00"
        End If
        
        'VP
        'OA - 55min
        'A7 - 24h
        
170     EncodeTPDU = "003100" & sLen & sType & sss & "00" & DSC & "A7" & pduRet
180     TPDULen = (VBA.Len(EncodeTPDU) - 2) / 2

    '<EhFooter>
lb_out:
        Exit Function

EncodeTPDU_Err:
        LogError "EncodeTPDU"
        Resume lb_out
    '</EhFooter>
End Function

Public Function pdu2text(pdu As String, ByVal pduLen As Integer) As String
Dim i As Long, octet As Long, septet As Long, remainder As Long, divider As Long

  remainder = 0
  For i = 0 To Len(pdu) \ 2 - 1
    octet = CByte("&H" & Mid(pdu, i * 2 + 1, 2))
    septet = (octet * 2 ^ (i Mod 7) + remainder) And 127
    divider = 2 ^ (7 - (i Mod 7))
    remainder = octet \ divider
    pdu2text = pdu2text & Chr(septet)
    If Len(pdu2text) = pduLen Then Exit For
    If (i Mod 7) = 6 Then
      pdu2text = pdu2text & Chr(remainder)
      remainder = 0
    End If
  Next
  
  pdu2text = VBA.Trim$(pdu2text)
  pdu2text = VBA.Replace(pdu2text, Chr(0), "")
'  i = VBA.InStrRev(pdu2text, Chr(0))
'  If i > 0 Then
'    pdu2text = VBA.Mid$(pdu2text, 1, i - 1)
'  End If

End Function

Public Function PhoneEncode(ByVal PhoneNumber As String, ByRef PhoneLen As Integer, Optional ByVal PhoneType As String = "") As String
Dim sAbonent As String
Dim i As Integer
Dim sss As String
Dim phLen As Integer
Dim s As String

    sAbonent = VBA.Trim$(PhoneNumber)
    s = VBA.Mid$(sAbonent, 1, 1)
    If s = "+" Then
        sAbonent = VBA.Mid$(sAbonent, 2)
    End If
    If PhoneType = "B" Then
        '     +7903...
        If VBA.Mid$(sAbonent, 2, 3) = "095" Then
            sAbonent = VBA.Mid$(sAbonent, 1, 1) & "903" & VBA.Mid$(sAbonent, 5)
        End If
    End If
    phLen = Len(sAbonent)
    sss = ""
    For i = 1 To phLen - 1 Step 2
        s = VBA.Mid$(sAbonent, i + 1, 1) & VBA.Mid$(sAbonent, i, 1)
        sss = sss & s
    Next i
    If (phLen Mod 2) Then
        sss = sss & "F" & VBA.Right$(sAbonent, 1)
    Else
        sss = sss
    End If
    PhoneLen = phLen
    PhoneEncode = sss

End Function

Public Function ANSIDecode(ByVal Value As String) As String
Dim i As Integer
Dim s As String
Dim sss As String
    
    sss = ""
    For i = 1 To Len(Value) - 1 Step 2
        s = VBA.Mid$(Value, i, 2)
        s = VBA.Chr(VBA.CLng("&H" & s))
        sss = sss & s
    Next i
    ANSIDecode = sss
    
End Function

Public Function ANSIEncode(ByVal Value As String) As String
Dim i As Long
Dim s As String
Dim sss As String

    sss = ""
    For i = 1 To Len(Value)
        s = VBA.Mid$(Value, i, 1)
        s = VBA.Hex$(VBA.Asc(s))
        sss = sss & s
    Next i
    ANSIEncode = sss

End Function


Public Function USC2Decode(ByVal Value As String) As String
On Error GoTo err_debug
Dim i As Integer
Dim s As String
Dim sss As String
    
    sss = ""
    For i = 1 To Len(Value) - 3 Step 4
        s = VBA.Mid$(Value, i, 4)
        s = VBA.ChrW(VBA.CLng("&H" & s))
        sss = sss & s
    Next i
    USC2Decode = sss
lb_out:
    Exit Function
    
err_debug:
    LogError "USC2Decode"
    Resume lb_out
    
End Function

Public Function USC2Encode(ByVal Value As String) As String
Dim i As Integer
Dim s As String
Dim sss As String
    
    sss = ""
    For i = 1 To Len(Value)
        s = VBA.Mid$(Value, i, 1)
        s = VBA.Hex$(VBA.AscW(s))
        If Len(s) < 4 Then
            s = VBA.String$(4 - VBA.Len(s), "0") & s
        End If
        sss = sss & s
    Next i
    USC2Encode = sss
    
End Function


Public Function IsUSC2(ByVal Value As String) As Boolean
On Error GoTo err_debug
Dim i As Long
Dim s As String

    If VBA.Len(Value) = 0 Then Exit Function
    s = VBA.Mid$(Value, 1, 2)
    If s = "00" Then
        IsUSC2 = True
    End If
lb_out:
    Exit Function
    
err_debug:
    LogError "IsUSC2"
    Resume lb_out

End Function
